diff --git a/contrib/ntp/sntp/tests/packetProcessing.c b/contrib/ntp/sntp/tests/packetProcessing.c
index 53c454a9f064..0e7fedee271c 100644
--- a/contrib/ntp/sntp/tests/packetProcessing.c
+++ b/contrib/ntp/sntp/tests/packetProcessing.c
@@ -15,7 +15,6 @@ extern int key_cnt;
 
 
 void PrepareAuthenticationTest(int key_id,int key_len,const char* type,const void* key_seq);
-void PrepareAuthenticationTestMD5(int key_id,int key_len,const void* key_seq);
 void setUp(void);
 void tearDown(void);
 void test_TooShortLength(void);
@@ -35,14 +34,15 @@ void test_RejectWrongResponseServerMode(void);
 void test_AcceptNoSentPacketBroadcastMode(void);
 void test_CorrectUnauthenticatedPacket(void);
 void test_CorrectAuthenticatedPacketMD5(void);
+void test_CorrectAuthenticatedPacketSHAKE128(void);
 void test_CorrectAuthenticatedPacketSHA1(void);
 void test_CorrectAuthenticatedPacketCMAC(void);
 
 /* [Bug 2998] There are some issues whith the definition of 'struct pkt'
  * when AUTOKEY is undefined -- the formal struct is too small to hold
  * all the extension fields that are going to be tested. We have to make
- * sure we have the extra bytes, or the test yield undefined results due
- * to buffer overrun. 
+ * sure we have the extra bytes, or the test yields undefined results due
+ * to buffer overrun.
  */
 #ifndef AUTOKEY
 # define EXTRA_BUFSIZE 256
@@ -53,7 +53,7 @@ void test_CorrectAuthenticatedPacketCMAC(void);
 union tpkt {
 	struct pkt p;
 	u_char     b[sizeof(struct pkt) + EXTRA_BUFSIZE];
-}; 
+};
 
 static union tpkt testpkt;
 static union tpkt testspkt;
@@ -70,34 +70,27 @@ PrepareAuthenticationTest(
 	)
 {
 	char str[25];
-	snprintf(str, 25, "%d", key_id);
+
+	snprintf(str, sizeof(str), "%d", key_id);
 	ActivateOption("-a", str);
 
 	key_cnt = 1;
-	key_ptr = emalloc(sizeof(struct key));
+	if (NULL == key_ptr) {
+		key_ptr = emalloc(sizeof(*key_ptr));
+	}
 	key_ptr->next = NULL;
 	key_ptr->key_id = key_id;
 	key_ptr->key_len = key_len;
-	memcpy(key_ptr->typen, type, strlen(type) + 1);
+	strncpy(key_ptr->typen, type, sizeof(key_ptr->typen));
 
 	TEST_ASSERT_TRUE(key_len < sizeof(key_ptr->key_seq));
 
-	memcpy(key_ptr->key_seq, key_seq, key_ptr->key_len);
+	memcpy(key_ptr->key_seq, key_seq,
+	       min(key_len, sizeof(key_ptr->key_seq)));
 	restoreKeyDb = true;
 }
 
 
-void
-PrepareAuthenticationTestMD5(
-	int 		key_id,
-	int 		key_len,
-	const void *	key_seq
-	)
-{
-	PrepareAuthenticationTest(key_id, key_len, "MD5", key_seq);
-}
-
-
 void
 setUp(void)
 {
@@ -109,7 +102,7 @@ setUp(void)
 	 * so they contain at least some valid data.
 	 */
 	testpkt.p.li_vn_mode = PKT_LI_VN_MODE(LEAP_NOWARNING, NTP_VERSION,
-										MODE_SERVER);
+					      MODE_SERVER);
 	testpkt.p.stratum = STRATUM_REFCLOCK;
 	memcpy(&testpkt.p.refid, "GPS\0", 4);
 
@@ -127,7 +120,7 @@ setUp(void)
 
 void
 tearDown(void)
-{	
+{
 	if (restoreKeyDb) {
 		key_cnt = 0;
 		free(key_ptr);
@@ -171,7 +164,7 @@ test_TooShortExtensionFieldLength(void)
 	 * still...
 	 */
 	uint32_t * pe = testpkt.p.exten + 7;
-	
+
 	/* The lower 16-bits are the length of the extension field.
 	 * This lengths must be multiples of 4 bytes, which gives
 	 * a minimum of 4 byte extension field length.
@@ -224,19 +217,20 @@ test_CryptoNAKPacketReject(void)
 void
 test_AuthenticatedPacketInvalid(void)
 {
+#ifdef OPENSSL
+	size_t pkt_len = LEN_PKT_NOMAC;
+	size_t mac_len;
+
 	/* Activate authentication option */
-	PrepareAuthenticationTestMD5(50, 9, "123456789");
+	PrepareAuthenticationTest(50, 9, "SHAKE128", "123456789");
 	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
-	
-	/* Prepare the packet. */
-	int pkt_len = LEN_PKT_NOMAC;
 
+	/* Prepare the packet. */
 	testpkt.p.exten[0] = htonl(50);
-	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
-			       &testpkt.p.exten[1]);
+	mac_len = make_mac(&testpkt.p, pkt_len, key_ptr,
+			   &testpkt.p.exten[1], MAX_MDG_LEN);
 
-	pkt_len += 4 + mac_len;
+	pkt_len += KEY_MAC_LEN + mac_len;
 
 	/* Now, alter the MAC so it becomes invalid. */
 	testpkt.p.exten[1] += 1;
@@ -244,30 +238,43 @@ test_AuthenticatedPacketInvalid(void)
 	TEST_ASSERT_EQUAL(SERVER_AUTH_FAIL,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
+
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not enabled, skipping...");
+
+#endif
 }
 
 
 void
 test_AuthenticatedPacketUnknownKey(void)
 {
+#ifdef OPENSSL
+	size_t pkt_len = LEN_PKT_NOMAC;
+	size_t mac_len;
+
 	/* Activate authentication option */
-	PrepareAuthenticationTestMD5(30, 9, "123456789");
+	PrepareAuthenticationTest(30, 9, "SHAKE128", "123456789");
 	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
-	
+
 	/* Prepare the packet. Note that the Key-ID expected is 30, but
 	 * the packet has a key id of 50.
 	 */
-	int pkt_len = LEN_PKT_NOMAC;
-
 	testpkt.p.exten[0] = htonl(50);
-	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
-			       &testpkt.p.exten[1]);
+	mac_len = make_mac(&testpkt.p, pkt_len, key_ptr,
+			   &testpkt.p.exten[1], MAX_MDG_LEN);
 	pkt_len += KEY_MAC_LEN + mac_len;
 
 	TEST_ASSERT_EQUAL(SERVER_AUTH_FAIL,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
+
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not enabled, skipping...");
+
+#endif
 }
 
 
@@ -282,7 +289,7 @@ test_ServerVersionTooOld(void)
 	TEST_ASSERT_TRUE(PKT_VERSION(testpkt.p.li_vn_mode) < NTP_OLDVERSION);
 
 	int pkt_len = LEN_PKT_NOMAC;
-	
+
 	TEST_ASSERT_EQUAL(SERVER_UNUSEABLE,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
@@ -418,44 +425,96 @@ test_CorrectUnauthenticatedPacket(void)
 void
 test_CorrectAuthenticatedPacketMD5(void)
 {
-	PrepareAuthenticationTestMD5(10, 15, "123456789abcdef");
+#ifdef OPENSSL
+
+	keyid_t k_id = 10;
+	int pkt_len = LEN_PKT_NOMAC;
+	int mac_len;
+
+	PrepareAuthenticationTest(k_id, 15, "MD5", "123456789abcdef");
 	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
 
+	/* Prepare the packet. */
+	testpkt.p.exten[0] = htonl(k_id);
+	mac_len = make_mac(&testpkt.p, pkt_len, key_ptr,
+			   &testpkt.p.exten[1], MAX_MDG_LEN);
+
+	/* TODO: Should not expect failure if non-FIPS OpenSSL */
+	TEST_EXPECT_FAIL_MESSAGE("FIPS OpenSSL bars MD5");
+
+	pkt_len += KEY_MAC_LEN + mac_len;
+
+	TEST_ASSERT_EQUAL(pkt_len,
+			  process_pkt(&testpkt.p, &testsock, pkt_len,
+				      MODE_SERVER, &testspkt.p, "UnitTest"));
+
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not enabled, skipping...");
+
+#endif
+}
+
+
+void
+test_CorrectAuthenticatedPacketSHAKE128(void)
+{
+#ifdef OPENSSL
+
+	keyid_t k_id = 10;
 	int pkt_len = LEN_PKT_NOMAC;
+	int mac_len;
+
+	PrepareAuthenticationTest(k_id, 15, "SHAKE128", "123456789abcdef");
+	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
 
 	/* Prepare the packet. */
-	testpkt.p.exten[0] = htonl(10);
-	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MD5_LEN - KEY_MAC_LEN, key_ptr,
-			       &testpkt.p.exten[1]);
+	testpkt.p.exten[0] = htonl(k_id);
+	mac_len = make_mac(&testpkt.p, pkt_len, key_ptr, &testpkt.p.exten[1],
+			   SHAKE128_LENGTH);
 
 	pkt_len += KEY_MAC_LEN + mac_len;
 
 	TEST_ASSERT_EQUAL(pkt_len,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
+
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not enabled, skipping...");
+
+#endif
 }
 
 
 void
 test_CorrectAuthenticatedPacketSHA1(void)
 {
-	PrepareAuthenticationTest(20, 15, "SHA1", "abcdefghijklmno");
-	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
+#ifdef OPENSSL
 
+	keyid_t k_id = 20;
 	int pkt_len = LEN_PKT_NOMAC;
+	int mac_len;
+
+	PrepareAuthenticationTest(k_id, 15, "SHA1", "abcdefghijklmno");
+	TEST_ASSERT_TRUE(ENABLED_OPT(AUTHENTICATION));
 
 	/* Prepare the packet. */
-	testpkt.p.exten[0] = htonl(20);
-	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MDG_LEN, key_ptr,
-			       &testpkt.p.exten[1]);
+	testpkt.p.exten[0] = htonl(k_id);
+	mac_len = make_mac(&testpkt.p, pkt_len, key_ptr, &testpkt.p.exten[1],
+			   SHA1_LENGTH);
 
 	pkt_len += KEY_MAC_LEN + mac_len;
 
 	TEST_ASSERT_EQUAL(pkt_len,
 			  process_pkt(&testpkt.p, &testsock, pkt_len,
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
+
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not enabled, skipping...");
+
+#endif
 }
 
 
@@ -471,9 +530,8 @@ test_CorrectAuthenticatedPacketCMAC(void)
 
 	/* Prepare the packet. */
 	testpkt.p.exten[0] = htonl(30);
-	int mac_len = make_mac(&testpkt.p, pkt_len,
-			       MAX_MAC_LEN, key_ptr,
-			       &testpkt.p.exten[1]);
+	int mac_len = make_mac(&testpkt.p, pkt_len, key_ptr,
+			       &testpkt.p.exten[1], MAX_MAC_LEN);
 
 	pkt_len += 4 + mac_len;
 
@@ -482,9 +540,9 @@ test_CorrectAuthenticatedPacketCMAC(void)
 				      MODE_SERVER, &testspkt.p, "UnitTest"));
 
 #else
-	
-	TEST_IGNORE_MESSAGE("OpenSSL CMAC not used, skipping...");
-	
+
+	TEST_IGNORE_MESSAGE("CMAC not enabled, skipping...");
+
 #endif	/* OPENSSL */
 }
 
diff --git a/contrib/ntp/sntp/tests/run-crypto.c b/contrib/ntp/sntp/tests/run-crypto.c
index a486f86c4035..83e8d19434aa 100644
--- a/contrib/ntp/sntp/tests/run-crypto.c
+++ b/contrib/ntp/sntp/tests/run-crypto.c
@@ -30,10 +30,10 @@
 //=======External Functions This Runner Calls=====
 extern void setUp(void);
 extern void tearDown(void);
-extern void test_MakeMd5Mac(void);
+extern void test_MakeSHAKE128Mac(void);
 extern void test_MakeSHA1Mac(void);
 extern void test_MakeCMac(void);
-extern void test_VerifyCorrectMD5(void);
+extern void test_VerifySHAKE128(void);
 extern void test_VerifySHA1(void);
 extern void test_VerifyCMAC(void);
 extern void test_VerifyFailure(void);
@@ -66,14 +66,14 @@ int main(int argc, char *argv[])
   progname = argv[0];
   suite_setup();
   UnityBegin("crypto.c");
-  RUN_TEST(test_MakeMd5Mac, 15);
-  RUN_TEST(test_MakeSHA1Mac, 16);
-  RUN_TEST(test_MakeCMac, 17);
-  RUN_TEST(test_VerifyCorrectMD5, 18);
-  RUN_TEST(test_VerifySHA1, 19);
-  RUN_TEST(test_VerifyCMAC, 20);
-  RUN_TEST(test_VerifyFailure, 21);
-  RUN_TEST(test_PacketSizeNotMultipleOfFourBytes, 22);
+  RUN_TEST(test_MakeSHAKE128Mac, 14);
+  RUN_TEST(test_MakeSHA1Mac, 15);
+  RUN_TEST(test_MakeCMac, 16);
+  RUN_TEST(test_VerifySHAKE128, 17);
+  RUN_TEST(test_VerifySHA1, 18);
+  RUN_TEST(test_VerifyCMAC, 19);
+  RUN_TEST(test_VerifyFailure, 20);
+  RUN_TEST(test_PacketSizeNotMultipleOfFourBytes, 21);
 
   return (UnityEnd());
 }
diff --git a/contrib/ntp/sntp/tests/run-packetProcessing.c b/contrib/ntp/sntp/tests/run-packetProcessing.c
index c91a6d340a39..eeeb6f1bf2f6 100644
--- a/contrib/ntp/sntp/tests/run-packetProcessing.c
+++ b/contrib/ntp/sntp/tests/run-packetProcessing.c
@@ -47,6 +47,7 @@ extern void test_RejectWrongResponseServerMode(void);
 extern void test_AcceptNoSentPacketBroadcastMode(void);
 extern void test_CorrectUnauthenticatedPacket(void);
 extern void test_CorrectAuthenticatedPacketMD5(void);
+extern void test_CorrectAuthenticatedPacketSHAKE128(void);
 extern void test_CorrectAuthenticatedPacketSHA1(void);
 extern void test_CorrectAuthenticatedPacketCMAC(void);
 
@@ -77,25 +78,26 @@ int main(int argc, char *argv[])
   progname = argv[0];
   suite_setup();
   UnityBegin("packetProcessing.c");
-  RUN_TEST(test_TooShortLength, 23);
-  RUN_TEST(test_LengthNotMultipleOfFour, 24);
-  RUN_TEST(test_TooShortExtensionFieldLength, 25);
-  RUN_TEST(test_UnauthenticatedPacketReject, 26);
-  RUN_TEST(test_CryptoNAKPacketReject, 27);
-  RUN_TEST(test_AuthenticatedPacketInvalid, 28);
-  RUN_TEST(test_AuthenticatedPacketUnknownKey, 29);
-  RUN_TEST(test_ServerVersionTooOld, 30);
-  RUN_TEST(test_ServerVersionTooNew, 31);
-  RUN_TEST(test_NonWantedMode, 32);
-  RUN_TEST(test_KoDRate, 33);
-  RUN_TEST(test_KoDDeny, 34);
-  RUN_TEST(test_RejectUnsyncedServer, 35);
-  RUN_TEST(test_RejectWrongResponseServerMode, 36);
-  RUN_TEST(test_AcceptNoSentPacketBroadcastMode, 37);
-  RUN_TEST(test_CorrectUnauthenticatedPacket, 38);
-  RUN_TEST(test_CorrectAuthenticatedPacketMD5, 39);
-  RUN_TEST(test_CorrectAuthenticatedPacketSHA1, 40);
-  RUN_TEST(test_CorrectAuthenticatedPacketCMAC, 41);
+  RUN_TEST(test_TooShortLength, 20);
+  RUN_TEST(test_LengthNotMultipleOfFour, 21);
+  RUN_TEST(test_TooShortExtensionFieldLength, 22);
+  RUN_TEST(test_UnauthenticatedPacketReject, 23);
+  RUN_TEST(test_CryptoNAKPacketReject, 24);
+  RUN_TEST(test_AuthenticatedPacketInvalid, 25);
+  RUN_TEST(test_AuthenticatedPacketUnknownKey, 26);
+  RUN_TEST(test_ServerVersionTooOld, 27);
+  RUN_TEST(test_ServerVersionTooNew, 28);
+  RUN_TEST(test_NonWantedMode, 29);
+  RUN_TEST(test_KoDRate, 30);
+  RUN_TEST(test_KoDDeny, 31);
+  RUN_TEST(test_RejectUnsyncedServer, 32);
+  RUN_TEST(test_RejectWrongResponseServerMode, 33);
+  RUN_TEST(test_AcceptNoSentPacketBroadcastMode, 34);
+  RUN_TEST(test_CorrectUnauthenticatedPacket, 35);
+  RUN_TEST(test_CorrectAuthenticatedPacketMD5, 36);
+  RUN_TEST(test_CorrectAuthenticatedPacketSHAKE128, 37);
+  RUN_TEST(test_CorrectAuthenticatedPacketSHA1, 38);
+  RUN_TEST(test_CorrectAuthenticatedPacketCMAC, 39);
 
   return (UnityEnd());
 }
diff --git a/contrib/ntp/sntp/unity/unity_internals.h b/contrib/ntp/sntp/unity/unity_internals.h
index a04f52b478bb..3d22e7aa20e8 100644
--- a/contrib/ntp/sntp/unity/unity_internals.h
+++ b/contrib/ntp/sntp/unity/unity_internals.h
@@ -519,6 +519,9 @@ void UnityAssertDoubleSpecial(const _UD actual,
                               const UNITY_FLOAT_TRAIT_T style);
 #endif
 
+void UnityExpectFailMessage(const char* msg,
+                            const UNITY_LINE_TYPE line);
+
 //-------------------------------------------------------
 // Error Strings We Might Need
 //-------------------------------------------------------
@@ -708,8 +711,7 @@ extern const char UnityStrErr64[];
 //End of UNITY_INTERNALS_H
 #endif
 
-//#define TEST_EXPECT_FAIL()																		Unity.isExpectingFail = 1;
-//#define TEST_EXPECT_FAIL_MESSAGE(message)														Unity.isExpectingFail = 1; Unity.XFAILMessage = message; //PROBLEM : does this work on all compilers?
+// Not part of standard distribution
 
-#define TEST_EXPECT_FAIL()																		UnityExpectFail();
-#define TEST_EXPECT_FAIL_MESSAGE(message)														UnityExpectFailMessage( (message) );
+#define TEST_EXPECT_FAIL()									UnityExpectFail();
+#define TEST_EXPECT_FAIL_MESSAGE(message)							UnityExpectFailMessage((message), __LINE__);
diff --git a/contrib/ntp/sntp/utilities.h b/contrib/ntp/sntp/utilities.h
index a022c7d49769..4503877bc256 100644
--- a/contrib/ntp/sntp/utilities.h
+++ b/contrib/ntp/sntp/utilities.h
@@ -7,7 +7,6 @@
 
 #include "ntp.h"
 #include "ntp_stdlib.h"
-#include "lib_strbuf.h"
 
 #define HLINE "--------------------------------------------------------------------------------\n"
 #define PHLINE fprintf(output, HLINE);
diff --git a/contrib/ntp/tests/libntp/data/ntp.keys b/contrib/ntp/tests/libntp/data/ntp.keys
index 6c8c743fd7d2..ef634dd00ebd 100644
--- a/contrib/ntp/tests/libntp/data/ntp.keys
+++ b/contrib/ntp/tests/libntp/data/ntp.keys
@@ -1,15 +1,16 @@
-# This unit test ntp.keys file has hard-coded the current set
-# of OpenSSL-supported digest algorithms.  It needs to be updated
-# after newer algorithms are available.  The current list can be
+# This unit test ntp.keys file has hard-coded the union of sets
+# of OpenSSL-supported digest algorithms we've come across.  It
+# needs to be updated as algorithms are observed.  A list can be
 # obtained with:
 #
 # ntpq -c "help keytype"
 #
-# tests/libntp/digest.c similarly hardcodes the list of digests
-# to test.
+# tests/libntp/digests.c similarly hardcodes the list of digests
+# to test.  This file must be kept in sync with it.
 #
 # Each digest is tested twice with keyids separated by 50 for
 # plaintext and hex-encoded keys.
+#
 
  1 AES128CMAC	X~A=%NWlo]p$dGq,S3M9
  2 MD4		oV'8?f+J5`_EOvW!B,R`
@@ -18,9 +19,9 @@
  5 RIPEMD160	I89p}f6QopwC\LwHBm;e
  6 SHA1		A;H=E;.m4N%t%EeJ90[d
  7 SHAKE128	|HxLoa,mzG<"y>^TI_(1
- 8 MD5		306+^SHLV5{"v7W`U3aY	# unused so far
- 9 MD5		lGyKZgsI_Pi"y"8JAT98	# unused
-10 MD5		2:VO]Q5u%/b&}.<P?T~9	# unused
+ 8 DSA		306+^SHLV5{"v7W`U3aY
+ 9 DSA-SHA	lGyKZgsI_Pi"y"8JAT98
+10 SHA		2:VO]Q5u%/b&}.<P?T~9
 
 51 AES128CMAC 	d0cd9f3ee181769ca7cccaada09f093c5fe8e628
 52 MD4		7080bc47eea6b379b2ff841805a144fb4a241a16
@@ -29,6 +30,6 @@
 55 RIPEMD160	6028ec169bfbe55ab61ffa7baa34b482020f0619
 56 SHA1		17d96a86eb9b9075f33e1c0a08bb2bb61e916e33
 57 SHAKE128	70da1a91030eb91836c1cf76cf67ddfd6b96fa91
-58 SHA1		7ce5deea7569d7423d5e1b497c8eb3bfeff852d5	# unused so far
-59 SHA1		9fd568e8f371deae54a65bc50b52bbe1f6529589	# unused
-60 SHA1		ce85046978a4df8366e102c4f1267399bbc25737	# unused
+58 DSA		7ce5deea7569d7423d5e1b497c8eb3bfeff852d5
+59 DSA-SHA	9fd568e8f371deae54a65bc50b52bbe1f6529589
+60 SHA		ce85046978a4df8366e102c4f1267399bbc25737
diff --git a/contrib/ntp/tests/libntp/digests.c b/contrib/ntp/tests/libntp/digests.c
index 03e9ef1b838e..10b9d2c12ac0 100644
--- a/contrib/ntp/tests/libntp/digests.c
+++ b/contrib/ntp/tests/libntp/digests.c
@@ -110,7 +110,7 @@ do {									\
 	authtrust((key), 1);						\
 									\
 	res_sz = authencrypt((key), pkt, pkt_sz);			\
-	if (KEY_MAC_LEN == res_sz) {					\
+	if (0 == res_sz) {						\
 		TEST_IGNORE_MESSAGE("Likely OpenSSL 3 failed digest "	\
 				    "init.");				\
 		return;							\
@@ -363,7 +363,7 @@ void test_Digest_SHAKE128(void)
 			0xaa, 0xa6, 0xcd, 0x76
 		};
 	u_char expectedB[MAX_MAC_LEN] =
-		{ 
+		{
 			0, 0, 0, KEYID_B,
 			0x07, 0x04, 0x63, 0xcc,
 			0x46, 0xaf, 0xca, 0x00,
@@ -380,6 +380,123 @@ void test_Digest_SHAKE128(void)
 }
 
 
+#define DSA_KEYID		8
+#undef KEYID_A
+#define KEYID_A			DSA_KEYID
+#undef DG_SZ
+#define DG_SZ			20
+#undef KEYID_B
+#define KEYID_B			(KEYID_A + HEX_KEYID_OFFSET)
+void test_Digest_DSA(void);
+void test_Digest_DSA(void)
+{
+#ifdef OPENSSL
+	u_char expectedA[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_A,
+			0xaf, 0xa0, 0x1d, 0x0c,
+			0x92, 0xcb, 0xca, 0x95,
+			0x0d, 0x57, 0x60, 0x49,
+			0xe5, 0x28, 0x03, 0xf2,
+			0x7b, 0x5b, 0xb1, 0x4a
+		};
+	u_char expectedB[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_B,
+			0x77, 0xcd, 0x88, 0xc2,
+			0xed, 0x5d, 0x57, 0xc5,
+			0x28, 0x92, 0xf0, 0x21,
+			0x2b, 0xb9, 0x48, 0xac,
+			0xfe, 0x9f, 0xf5, 0x1c
+		};
+
+	TEST_ASSERT(setup);
+	TEST_ONE_DIGEST(KEYID_A, DG_SZ, expectedA);
+	TEST_ONE_DIGEST(KEYID_B, DG_SZ, expectedB);
+#else	/* ! OPENSSL follows  */
+	TEST_IGNORE_MESSAGE("Skipping, no OPENSSL");
+#endif
+}
+
+
+#define DSA_SHA_KEYID		9
+#undef KEYID_A
+#define KEYID_A			DSA_SHA_KEYID
+#undef DG_SZ
+#define DG_SZ			20
+#undef KEYID_B
+#define KEYID_B			(KEYID_A + HEX_KEYID_OFFSET)
+void test_Digest_DSA_SHA(void);
+void test_Digest_DSA_SHA(void)
+{
+#ifdef OPENSSL
+	u_char expectedA[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_A,
+			0x7c, 0xb5, 0x79, 0xd0,
+			0xf2, 0xcd, 0x47, 0xc0,
+			0x21, 0xf3, 0xf5, 0x04,
+			0x10, 0xc4, 0x59, 0x5c,
+			0xd9, 0xa4, 0x4f, 0x3b
+		};
+	u_char expectedB[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_B,
+			0xb9, 0xca, 0xa6, 0x8e,
+			0xd3, 0xcb, 0x94, 0x6a,
+			0x6d, 0xae, 0xb4, 0xc8,
+			0x0e, 0xc9, 0xf6, 0xed,
+			0x58, 0x1a, 0xed, 0x22
+		};
+
+	TEST_ASSERT(setup);
+	TEST_ONE_DIGEST(KEYID_A, DG_SZ, expectedA);
+	TEST_ONE_DIGEST(KEYID_B, DG_SZ, expectedB);
+#else	/* ! OPENSSL follows  */
+	TEST_IGNORE_MESSAGE("Skipping, no OPENSSL");
+#endif
+}
+
+
+#define SHA_KEYID		10
+#undef KEYID_A
+#define KEYID_A			SHA_KEYID
+#undef DG_SZ
+#define DG_SZ			20
+#undef KEYID_B
+#define KEYID_B			(KEYID_A + HEX_KEYID_OFFSET)
+void test_Digest_SHA(void);
+void test_Digest_SHA(void)
+{
+#ifdef OPENSSL
+	u_char expectedA[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_A,
+			0xd5, 0xbd, 0xb8, 0x55,
+			0x9b, 0x9e, 0x5e, 0x8f,
+			0x1a, 0x3d, 0x99, 0x60,
+			0xbd, 0x70, 0x0c, 0x5c,
+			0x68, 0xae, 0xb0, 0xbd
+		};
+	u_char expectedB[MAX_MAC_LEN] =
+		{
+			0, 0, 0, KEYID_B,
+			0x63, 0x05, 0x41, 0x45,
+			0xe9, 0x61, 0x84, 0xe7,
+			0xc6, 0x94, 0x24, 0xa4,
+			0x84, 0x76, 0xc7, 0xc9,
+			0xdd, 0x80, 0x80, 0x89
+		};
+
+	TEST_ASSERT(setup);
+	TEST_ONE_DIGEST(KEYID_A, DG_SZ, expectedA);
+	TEST_ONE_DIGEST(KEYID_B, DG_SZ, expectedB);
+#else	/* ! OPENSSL follows  */
+	TEST_IGNORE_MESSAGE("Skipping, no OPENSSL");
+#endif
+}
+
+
 /*
  * Dump a MAC in a form easy to cut and paste into the expected declaration.
  */
@@ -395,8 +512,8 @@ void dump_mac(
 
 	dc += snprintf(dump + dc, sizeof(dump) - dc, "digest with key %u { ", keyid);
 
-	for (idx = 0; idx < octets; idx++) {
-		if (10 == idx) {
+	for (idx = 4; idx < octets; idx++) {
+		if (14 == idx) {
 			msyslog(LOG_DEBUG, "%s", dump);
 			dc = 0;
 		}
diff --git a/contrib/ntp/tests/libntp/run-digests.c b/contrib/ntp/tests/libntp/run-digests.c
index ae574d0e239e..bc56f1cb92e6 100644
--- a/contrib/ntp/tests/libntp/run-digests.c
+++ b/contrib/ntp/tests/libntp/run-digests.c
@@ -40,6 +40,9 @@ extern void test_Digest_MDC2(void);
 extern void test_Digest_RIPEMD160(void);
 extern void test_Digest_SHA1(void);
 extern void test_Digest_SHAKE128(void);
+extern void test_Digest_DSA(void);
+extern void test_Digest_DSA_SHA(void);
+extern void test_Digest_SHA(void);
 
 
 //=======Suite Setup=====
@@ -75,6 +78,9 @@ int main(int argc, char *argv[])
   RUN_TEST(test_Digest_RIPEMD160, 275);
   RUN_TEST(test_Digest_SHA1, 314);
   RUN_TEST(test_Digest_SHAKE128, 353);
+  RUN_TEST(test_Digest_DSA, 390);
+  RUN_TEST(test_Digest_DSA_SHA, 429);
+  RUN_TEST(test_Digest_SHA, 468);
 
   return (UnityEnd());
 }
diff --git a/contrib/ntp/util/Makefile.am b/contrib/ntp/util/Makefile.am
index cef623c592d0..db0e8e65d747 100644
--- a/contrib/ntp/util/Makefile.am
+++ b/contrib/ntp/util/Makefile.am
@@ -4,7 +4,8 @@ bin_PROGRAMS=	$(NTP_KEYGEN_DB) $(NTPTIME_DB) $(TICKADJ_DB) $(TIMETRIM_DB)
 libexec_PROGRAMS=	$(NTP_KEYGEN_DL) $(NTPTIME_DL) $(TICKADJ_DL) $(TIMETRIM_DL)
 sbin_PROGRAMS=	$(NTP_KEYGEN_DS) $(NTPTIME_DS) $(TICKADJ_DS) $(TIMETRIM_DS)
 
-EXTRA_PROGRAMS=	audio-pcm byteorder hist jitter kern longsize ntp-keygen \
+EXTRA_PROGRAMS=	audio-pcm byteorder hist jitter kern longsize lsf-times \
+	ntp-keygen \
 	ntptime pps-api precision sht testrs6000 tg tg2 tickadj timetrim
 
 AM_CFLAGS  = $(CFLAGS_NTP)
@@ -32,6 +33,7 @@ tickadj_LDADD=	../libntp/libntp.a $(LDADD_LIBNTP) $(LIBM) $(PTHREAD_LIBS) $(LDAD
 EXTRA_DIST=				\
 	invoke-ntp-keygen.menu		\
 	invoke-ntp-keygen.texi		\
+	lsf-times.c			\
 	ntp-keygen-opts.def		\
 	ntp-keygen.1ntp-keygenman	\
 	ntp-keygen.1ntp-keygenmdoc	\
diff --git a/contrib/ntp/util/lsf-times.c b/contrib/ntp/util/lsf-times.c
new file mode 100644
index 000000000000..5b719e13360f
--- /dev/null
+++ b/contrib/ntp/util/lsf-times.c
@@ -0,0 +1,220 @@
+#include "config.h"
+#include "ntp_calendar.h"
+
+#include <stdlib.h>
+#include <errno.h>
+
+#include "ntp_types.h"
+#include "ntp_fp.h"
+#include "vint64ops.h"
+
+/*
+ * If we're called with 1 arg, it's a u_long timestamp.
+ * If we're called with 3 args, we're expecting YYYY MM DD,
+ *   and MM must be 6 or 12, and DD must be 28,
+ * If we're called with 2 args, we're expecting YYYY MM, and
+ *   MM mst be 6 or 12, and we assume DD is 28.
+ */
+
+char *progname;
+static const char *MONTHS[] =
+                { "January", "February", "March", "April", "May", "June",
+		  "July", "August", "September", "October", "November",
+		  "December" };
+
+void usage(void);
+
+void
+usage(void)
+{
+	printf("Usage:\n");
+	printf(" %s nnnnnn\n", progname);
+	printf(" %s YYYY [6|12]\n", progname);
+	printf(" %s YYYY [6|12] 28\n", progname);
+
+	return;
+}
+
+
+int
+main(
+	int	argc,		/* command line options */
+	char	**argv		/* poiniter to list of tokens */
+	)
+{
+	int err = 0;
+	vint64 expires;
+	unsigned int year = 0;
+	unsigned int mon = 0;
+	unsigned int dom = 0;
+	int scount;
+	char *ep;
+	struct calendar cal = {0};
+
+	progname = argv[0];
+
+	switch(argc) {
+	 case 2:	/* 1 arg, must be a string of digits */
+		expires = strtouv64(argv[1], &ep, 10);
+
+		if (0 == *ep) {
+			ntpcal_ntp64_to_date(&cal, &expires);
+
+			printf("%02u %s %04u %02u:%02u:%02u\n"
+				, cal.monthday
+				, MONTHS[cal.month - 1]
+				, cal.year
+				, cal.hour
+				, cal.minute
+				, cal.second
+				);
+
+			exit(0);
+		} else {
+			printf("1 arg, but not a string of digits: <%s>\n",
+				argv[1]);
+			err = 1;
+		}
+		break;
+		;;
+	 case 3:	/* 2 args, must be YY MM, where MM is 6 or 12 */
+		dom = 28;
+		scount = sscanf(argv[1], "%u", &year);
+		if (1 == scount) {
+			// printf("2 args: year %u\n", year);
+		} else {
+			printf("2 args, but #1 is not a string of digits: <%s>\n", argv[1]);
+			err = 1;
+		}
+
+		scount = sscanf(argv[2], "%u", &mon);
+		if (1 == scount) {
+			if (6 == mon || 12 == mon) {
+				// printf("2 args: month %u\n", mon);
+			} else {
+				printf("2 arg, but #2 is not 6 or 12: <%d>\n", mon);
+				err = 1;
+			}
+		} else {
+			printf("2 arg, but #2 is not a string of digits: <%s>\n", argv[2]);
+			err = 1;
+		}
+
+		break;
+		;;
+	 case 4:	/* 3 args, YY MM DD, where MM is 6 or 12, DD is 28 */
+		scount = sscanf(argv[1], "%u", &year);
+		if (1 == scount) {
+			// printf("3 args: year %u\n", year);
+		} else {
+			printf("3 args, but #1 is not a string of digits: <%s>\n", argv[1]);
+			err = 1;
+		}
+
+		scount = sscanf(argv[2], "%u", &mon);
+		if (1 == scount) {
+			if (6 == mon || 12 == mon) {
+				// printf("3 args: month %u\n", mon);
+			} else {
+				printf("3 arg, but #2 is not 6 or 12: <%d>\n", mon);
+				err = 1;
+			}
+		} else {
+			printf("3 arg, but #2 is not a string of digits: <%s>\n", argv[2]);
+			err = 1;
+		}
+
+		scount = sscanf(argv[3], "%u", &dom);
+		if (1 == scount) {
+			if (28 == dom) {
+				// printf("3 args: dom %u\n", dom);
+			} else {
+				printf("3 arg, but #3 is not 28: <%d>\n", dom);
+				err = 1;
+			}
+		} else {
+			printf("3 arg, but #3 is not a string of digits: <%s>\n", argv[2]);
+			err = 1;
+		}
+
+		break;
+		;;
+	 default:
+		err = 1;
+		break;
+		;;
+	}
+
+	if (err) {
+		usage();
+		exit(err);
+	}
+
+	cal.year = year;
+	cal.month = mon;
+	cal.monthday = dom;
+	cal.hour = 0;
+	cal.minute = 0;
+	cal.second = 0;
+
+	printf("%u ", ntpcal_date_to_ntp(&cal));
+
+	printf("%02d %s %04d "
+		, cal.monthday
+		, MONTHS[cal.month - 1]
+		, cal.year
+		);
+	printf("\n");
+
+	exit(err);
+}
+
+#if 0
+
+
+void
+test_DateGivenMonthDay(void) {
+	// 2010-06-24 12:50:00
+	struct calendar input = {2010, 0, 6, 24, 12, 50, 0};
+
+	u_long expected = 3486372600UL; // This is the timestamp above.
+
+	TEST_ASSERT_EQUAL_UINT(expected, caltontp(&input));
+}
+
+void
+test_DateGivenYearDay(void) {
+	// 2010-06-24 12:50:00
+	// This is the 175th day of 2010.
+	struct calendar input = {2010, 175, 0, 0, 12, 50, 0};
+
+	u_long expected = 3486372600UL; // This is the timestamp above.
+
+	TEST_ASSERT_EQUAL_UINT(expected, caltontp(&input));
+}
+
+void
+test_DateLeapYear(void) {
+	// 2012-06-24 12:00:00
+	// This is the 176th day of 2012 (since 2012 is a leap year).
+	struct calendar inputYd = {2012, 176, 0, 0, 12, 00, 00};
+	struct calendar inputMd = {2012, 0, 6, 24, 12, 00, 00};
+
+	u_long expected = 3549528000UL;
+
+	TEST_ASSERT_EQUAL_UINT(expected, caltontp(&inputYd));
+	TEST_ASSERT_EQUAL_UINT(expected, caltontp(&inputMd));
+}
+
+void
+test_WraparoundDateIn2036(void) {
+	// 2036-02-07 06:28:16
+	// This is (one) wrapping boundary where we go from ULONG_MAX to 0.
+	struct calendar input = {2036, 0, 2, 7, 6, 28, 16};
+
+	u_long expected = 0UL;
+
+	TEST_ASSERT_EQUAL_UINT(expected, caltontp(&input));
+}
+
+#endif
diff --git a/contrib/ntp/util/ntp-keygen-opts.c b/contrib/ntp/util/ntp-keygen-opts.c
index fb3c78fdff51..6d532651e3b2 100644
--- a/contrib/ntp/util/ntp-keygen-opts.c
+++ b/contrib/ntp/util/ntp-keygen-opts.c
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.c)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:38:24 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:04:43 AM by AutoGen 5.18.16
  *  From the definitions    ntp-keygen-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntp-keygen program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -76,8 +76,8 @@ extern FILE * option_usage_fp;
  *  static const strings for ntp-keygen options
  */
 static char const ntp_keygen_opt_strs[2443] =
-/*     0 */ "ntp-keygen (ntp) 4.2.8p17\n"
-            "Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+/*     0 */ "ntp-keygen (ntp) 4.2.8p18\n"
+            "Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
@@ -169,14 +169,14 @@ static char const ntp_keygen_opt_strs[2443] =
 /*  2223 */ "no-load-opts\0"
 /*  2236 */ "no\0"
 /*  2239 */ "NTP_KEYGEN\0"
-/*  2250 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p17\n"
+/*  2250 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p18\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n\0"
 /*  2365 */ "$HOME\0"
 /*  2371 */ ".\0"
 /*  2373 */ ".ntprc\0"
 /*  2380 */ "https://bugs.ntp.org, bugs@ntp.org\0"
 /*  2415 */ "\n\0"
-/*  2417 */ "ntp-keygen (ntp) 4.2.8p17";
+/*  2417 */ "ntp-keygen (ntp) 4.2.8p18";
 
 /**
  *  imbits option description:
@@ -1314,8 +1314,8 @@ static void bogus_function(void) {
      translate option names.
    */
   /* referenced via ntp_keygenOptions.pzCopyright */
-  puts(_("ntp-keygen (ntp) 4.2.8p17\n\
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntp-keygen (ntp) 4.2.8p18\n\
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -1413,14 +1413,14 @@ implied warranty.\n"));
   puts(_("load options from a config file"));
 
   /* referenced via ntp_keygenOptions.pzUsageTitle */
-  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p17\n\
+  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p18\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n"));
 
   /* referenced via ntp_keygenOptions.pzExplain */
   puts(_("\n"));
 
   /* referenced via ntp_keygenOptions.pzFullVersion */
-  puts(_("ntp-keygen (ntp) 4.2.8p17"));
+  puts(_("ntp-keygen (ntp) 4.2.8p18"));
 
   /* referenced via ntp_keygenOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
